/* 
 * i-scream central monitoring system
 * http://www.i-scream.org.uk
 * Copyright (C) 2000-2002 i-scream
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "ukcprog.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef FREEBSD
#include <sys/types.h>
#endif
#include <utmp.h>

char *get_user_stats(){
	char *xml_user_data;
	int nousers=0;
	char *user_list=NULL;
	char *user_tmp;
#if defined(LINUX) || defined(SOLARIS)
	struct utmp *entry;
#endif
#ifdef FREEBSD
	struct utmp entry;
	FILE *f;
#endif

#if defined(LINUX) || defined(SOLARIS)
	setutent();
	while((entry=getutent()) != NULL) {
		if(entry->ut_type==USER_PROCESS) {
			user_tmp=user_list;
			if(user_list==NULL){
				user_list=strdup(entry->ut_user);
			}else{
				user_list=strf("%s %s", user_list, entry->ut_user);
			}
			if(user_tmp!=NULL) free(user_tmp);
			nousers++;
		}
	}
	endutent();
#endif

#ifdef FREEBSD
	if ((f=fopen(_PATH_UTMP, "r")) == NULL){
		errf("Failed to open UTMP file (%m)");
		return NULL;
	}

	while((fread(&entry, sizeof(entry),1,f)) != 0){
		if (entry.ut_name[0] == '\0') continue;
		user_tmp=user_list;
		if(user_list==NULL){
			user_list=strdup(entry.ut_name);
		}else{
			user_list=strf("%s %s", user_list, entry.ut_name);
		}
		if(user_tmp!=NULL) free(user_tmp);
		nousers++;
	}

        if ((fclose(f)) != 0) {
                errf("Failed to close file (%m)");
                return NULL;
        }

#endif
	if (user_list==NULL){
		if((user_list=strdup("")) == NULL){
			errf("strdup failed (%m)");
			return NULL;
		}
	}
	if((xml_user_data=strf("<users><list>%s</list><count>%d</count></users>",user_list,nousers)) == NULL){
		errf("strf failed (%m)");
		return NULL;
	}
	if (user_list!=NULL) free(user_list);
	return xml_user_data;
}
